//---------------------------//
//----integration Piksi------//
//----Sven Burkart-----------//
//----Christian Leder--------//
//----Projekt HS 2014--------//
//---------------------------//

const unsigned int MAX_INPUT = 200;                    // max anzhalt message bytes (längere messages werden nicht gespeichert)

#include <Wire.h>
#include <Adafruit_RGBLCDShield.h>
#include <utility/Adafruit_MCP23017.h>

Adafruit_RGBLCDShield lcd = Adafruit_RGBLCDShield();
#define BLUE 0x4

void setup() {
                                                       // put your setup code here, to run once:
  
  Serial.begin(9600);                                //usb TX0
  Serial2.begin (115200);                              //GPS TX2
  Serial.println("About to enable LCD"); 
  //lcd.begin(16, 2);
  Serial.println("LCD Enabled");

}

void loop() {
                                                      // put your main code here, to run repeatedly: 
  //Serial.println("looping"); 
  //lcd.println("looping"); 
  while (Serial2.available () > 0)                   //wenn von piksi auf Arduinos TX 2 etwas empfangen wird,   When something is received from piksi on Arduinos TX 2,
  { 
    //Serial.println("there are bytes available to read"); 
    //lcd.print("there are bytes available to read"); 
    processIncomingByte(Serial2.read ());           //führe funktion process incomings aus.  //Perform function process incomings.
  } 
} 
                                                    // Protokoll auswerten  - Funktion um Aufzuschlüsseln    //Evaluate the protocol - Function to decrypt       
void processIncomingByte (const byte inByte)        //funktion um SBP zu filtern und nur die benötigte msg zu verwenden // Function to filter SBP and only evaluate the required msg to use protocol        
{ 
  Serial.print("Byte:  ");
  Serial.print(inByte , HEX);
  Serial.print("   ");
  Serial.println(inByte);
  static byte input_msg [MAX_INPUT];
  static unsigned int input_pos = 0;               // nicht negativer int und immer der gleiche int   //Not negative int and always the same int      
  
  if (inByte == 0x55)
  {
    if (input_pos == 29)
    {
      for( int i = 0 ; i < input_pos ; i++)
      {
        Serial.print(input_msg [i],HEX);        //If hex 55 print complete buffer [input_msg]  // wenn hex 55 print gesammter puffer [input_msg)       
        Serial.print(" ");
      }    
      Serial.println();                        //New line after completion Msg print // neue Zeile nach kpl. msg print          
      
      if((input_msg[0] == 0x03) && (input_msg[1] == 0x02))
      {
        Serial.println("Analyzing message. ");
        msg_analyse (input_msg);               //Function to analyze the filtered msg //funktion um die herausgefilterte msg zu analysieren           
      }
    }
    input_pos = 0;                            // und setzte input_pos wieder auf 0 //And set input_pos back to 0           
  }
  else
  {
    if (input_pos < (MAX_INPUT - 1))         // nur wenn pufferlänge nicht erreicht ist (in unserem Falle, wird das nicht der Fall sein) // Only if buffer is not reached (in our case, this will not be the case)          
    {
      input_msg [input_pos] = inByte;        // schreibt byte in puffer an position 0
      input_pos = input_pos + 1;             // erhöht position im Puffer um 1
    }
  }
  
}

void msg_analyse (byte byte_msg[29])     //Function to analyze the filtered message //funktion um die herausgefilterte msg zu analysieren         
{ 
  double east = 0; 
  double north = 0; 
  double dist=0; 
  north = bytesToInt (byte_msg[12], byte_msg[11], byte_msg[10], byte_msg[9]);    //Vertical deviation from base to (call of the function and which bytes are used) //vertikale abweichung von basis in  (aufruf der Funktion und welche bytes dazu verwendet werden)         
  east = bytesToInt (byte_msg[16], byte_msg[15], byte_msg[14], byte_msg[13]);    //Horizontal deviation from base to (call of the function and which bytes are used)  //horizontale abweichung von basis in mm (aufruf der Funktion und welche bytes dazu verwendet werden) 

  //lcd.print("north "); 
  //lcd.print(north); 
  //lcd.print(" ; east "); 
  //lcd.print(east); 
} 
  /*dist=sqrt(north*north+east*east);                // calc direct distance to base
  Serial.print(" ; direkte Distanz zur Basis ");            //direct distance to base in mm
  Serial.println(dist);
  
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------          
  //----calculating perpendicular distance to a line (point A to Point B)----//
  //----point A must be the Base-----Point be must be manualy definied-------//
  //----bei negativer perp_distance nach rechts korrigieren------------------//
  //----bei postitiver perp_distance nach links korrigieren------------------//
  
  int B_east = 5543.00;                                                     //east koordinate in mm von Basis für Punkt B    manuell definiert //east coordinate in mm from base to point b manually defined
  int B_north = -7989.00;                                                    //north koordinate in mm von Basis für Punkt B   manuell definiert
  int A_east = 1826.00;                                                      //east koordinate in mm von Basis für Punkt A    manuell definiert
  int A_north = -2329.00;                                                    //north koordinate in mm von Basis für Punkt A   manuell definiert
  int A = 0;                                                         // A aus allgemeiner Geradengleichung = Steigung //a from a general straight equation = pitch
  int B = -1;                                                        // B aus allgemeiner Geradengleichung Ax + Bx + C 
  int C = 0;                                                         // C aus allgemeiner Geradengleichung (C = Y-Achsenabschnitt)  //c from a general straight equation = y-intercept
  int perp_distance = 0;
  
  A=(B_north-A_north)/(B_east-A_east);                                //berechnen der Steigung
  C = B_north-(A*B_east);                                            //Berechnen der Y-Achsenabschnitt
  perp_distance = ((A*east)+(B*north)+C)/sqrt(A*A+B*B);              //Formel für perpendicular Distance to a line
  Serial.print("perpendicular Distance to line from Point A ( "); Serial.print(A_east);Serial.print(","); Serial.print(A_north); Serial.print(") to Point B ("); Serial.print(B_east);Serial.print(",");Serial.print(B_north);Serial.print("): ");
  Serial.println(perp_distance);
  Serial.println();
//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
}*/


int bytesToInt (int b4, int b3, int b2, int b1)    //4 bytes Move, compose and convert to decimal //4 bytes verschieben, zusammensetzen und zu dezimalzahl wandeln 
{
  int resultat=0;
  resultat=(b4 << 24) | (b3<<16) | (b2<<8) | b1;   // Bytes in resultatvariable to move to the left up to 4 bytes //bytes in resultatvariable nach links verschieben bis aus 4 bytes eine zahl wird 
  return resultat;
}
